#!/usr/bin/perl
#
# reichelt.pl - Gets price information from the reichelt.de website
#
# This program is part of part-db 
#
# 
# Copyright (C) 2005 Christoph Lechner
# http://www.cl-projects.de/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
# 
# $Id: reichelt.pl,v 1.1 2005/08/26 08:49:09 cl Exp $
#
# "PFL 10" funktioniert nicht einwandfrei!!!
# 
# Before running this program you have to adjust the supplier ID
# in "parts.id_supplier=1". Here 1 is the ID of the entry for Reichelt
# in the table suppliers. If yours is different you have to change this!
# You should enter your MySQL authentification information, too :)
#
# BTW: No comments, yet.
use strict;
use DBI;
use HTML::Parser ();
use IPC::Open2;
use LWP::UserAgent;
require HTTP::Request;

my $parser_state = 0;
my $parsed_price = -1;

sub h_text {
	my $p = shift;

	if ( $parser_state == 2 ) {
		$p =~ s/\ //g;
		if ( $p =~ m/\A(\d)+\.(\d)+/ ) {
			print "Got price: $p\n";
			$parsed_price = $p;
		}
		else {
			print "Unable to find out price\n";
			$parsed_price = -1;
		}
	}
}

sub h_tag {
	my $tag = shift;

	if ( ($tag =~ m/\<td class='schwarzklein' align='right' valign='middle'\>/) && ($parser_state == 0) ) {
		$parser_state = 1;
	}
	if ( ($tag =~ m/\<div class='schwarzkleinbold'\>/) && ($parser_state == 1) ) {
		$parser_state = 2;
	}
	if ( ($tag =~ m/\<\/div\>/) && ($parser_state == 2) ) {
		$parser_state = 0;
	}
}

sub URLEncode {
	my $theURL = $_[0];
	$theURL =~ s/([\W])/"%" . uc(sprintf("%2.2x",ord($1)))/eg;
	return $theURL;
}

# enter your username and password here
my $dbh = DBI->connect ("DBI:mysql:database=partdb;host=localhost", 'yourusernamehere', 'yourpasswordhere');

# if your entry for reichelt in 'suppliers' has a ID different from 1,
# you *should* adjust it here (in 'parts.id_supplier=1')
my $q = $dbh->prepare ("SELECT parts.id,parts.supplierpartnr FROM parts LEFT JOIN preise ON parts.id=preise.part_id WHERE (parts.id_supplier=1) AND ((preise.t IS NULL) OR (DATE_SUB(CURDATE(), INTERVAL 28 DAY) > preise.t));");
$q->execute;
while (my $ref = $q->fetchrow_hashref ()) {
	print "Got a row: id=$ref->{'id'}, partnr=$ref->{'supplierpartnr'}\n";

	my $p = HTML::Parser->new (
				api_version => 3,
				text_h => [ \&h_text, "dtext" ],
				start_h => [ \&h_tag, "text"],
				end_h => [ \&h_tag, "text"]);
				
	my $r = HTTP::Request->new(GET => 'http://www.reichelt.de/inhalt.html?SID=10QYOm89S4AQoAAGQS1so856122b30949140e06829d8089a5da12;ACTION=3;SORT=artikel.artnr;ARTIKEL=' . URLEncode ($ref->{'supplierpartnr'}));	# $ref->{'supplierpartnr'}
	my $ua = LWP::UserAgent->new;
	my $response = $ua->request($r);
	$p->parse ($response->content());
	$p->eof();

	if ( $parsed_price != -1 ) {
		$dbh->do ("DELETE FROM preise WHERE part_id=$ref->{'id'};");
		my $i = "INSERT INTO preise (part_id,preis,t) VALUES ('$ref->{'id'}','$parsed_price',NOW());";
		print "$i\n";
		$dbh->do ($i);
		$parsed_price = -1;
	}
	else
	{
		print "Unable to find the price for \"$ref->{'supplierpartnr'}\"\n";
	}
}
$q->finish ();
